<template>
  <div :class="{'input-focused': focused, 'invalid': requiredStatus && touched || invalid}">
    <label :for="id" class="base-label">
      {{ label }}
    </label>
    <div
      class='base-input-wrapper'
    >
      <base-country-selection
        :id="'country-selection'"
        class='country-selection'
        :label="'country selection'"
        :list="country"
        item-key="country"
        :default-value="country[0]"
        @selected="(value) => selectCountry(value)"
      />
      <input
        :id="id"
        class="base-input"
        v-bind="$attrs"
        :placeholder="$attrs.placeholder"
        :value="value"
        @focus="focusHandler"
        @input="inputHandler"
        @blur="blurHandler"
      >
    </div>
  </div>
</template>

<script>
import BaseCountrySelection from './BaseCountrySelection'
export default {
  components: { BaseCountrySelection },
  props: {
    value: {
      type: String,
      default: ''
    },

    id: {
      type: String,
      default: ''
    },

    label: {
      type: String,
      default: ''
    },

    invalid: {
      type: Boolean,
      default: false
    },

    requiredField: {
      type: Boolean,
      default: false
    }

  },

  data() {
    return {
      focused: false,
      touched: false,
      country: [ { country: '+90', id: 1, value: '+90', img: 'turkey' }, { country: '+86', id: 2, value: '+86', img: 'turkey' }, { country: '+90', id: 3, value: '+90', img: 'turkey' }, { country: '+7', id: 4, value: '+7', img: 'turkey' }],
    }
  },

  computed: {
    valueNotEmpty() {
      return this.value.length > 4
    },
    requiredStatus(){
      if(this.requiredField) {
        return  this.value.length < 4
      }
      return false
    }
  },

  methods: {
    inputHandler(event) {
      this.$emit('input', event.target.value)
    },

    focusHandler() {
      this.focused = true
    },

    blurHandler() {
      this.touched = true
      this.focused = false
    },


    selectCountry (value) {
      this.$emit('input', value.value)
    },
  }
}
</script>

<style lang='scss' scoped>

.base-input-wrapper {
  border-bottom: 2px solid #3A4675;
  width: 100%;
  padding: 18px 0 18px 58px;
  position: relative;
  z-index: 1;

  transition: all 0.5s;
}

.country-selection {
  position: absolute;
  top: 50%;
  transform: translateY(-50%);
  left: 0;
}

.base-input {
  width: 100%;
  height: 20px;
  margin: 0;
  border: none;
  outline: none;
  padding: 0;
  background: transparent;
  font-size: 20px;
  color: #FFFFFF;

  @media(max-width: 767px) {
    font-size: 18px;
  }
}

.base-input::placeholder ,{
  color: rgba(255, 255, 255, 0.45);
  font-size: 20px;
  font-weight: 300;

  @media(max-width: 767px) {
    font-size: 18px;
  }
}

label {
  font-weight: 300;
  font-size: 16px;
  color: rgba(255, 255, 255, 0.45);
  transition: all 0.5s;
}

.input-focused {
  .base-input-wrapper {
    border-bottom: 2px solid #438AF9;
  }

  label {
    color: #438AF9;
  }
}

.invalid {
  .base-input-wrapper {
    border-bottom: 2px solid #FA5D2C;
  }

  label {
    color: #FA5D2C;
  }
}

.invalid-text {
  color: #FA5D2C;
  position: absolute;
  bottom: 48px;
  left: 0;
  font-size: 14px;
}

</style>
